struct task_object { /* was: m_proc_inf */
	MEDUSA_COMM_OBJECT_HEADER;

	int pid, parent_pid, child_pid, sibling_pid;	/* older sib. */
	int pgrp;
	unsigned short uid, euid, suid, fsuid;
	unsigned short gid, egid, sgid, fsgid;
	unsigned short luid;
	kernel_cap_t cap_effective, cap_inheritable, cap_permitted;
	struct med_proc mp;
};

#define OFFS(X) (int)(&(((task_object *)NULL)->(X)))

struct medusa_comm_attribute_s task_object_attrs[] = {
	{ "pid", MED_TYPE_INT | MED_TYPE_READ_ONLY | MED_TYPE_PRIMARY_KEY, OFFS(pid), sizeof(int) },
	{ "parent_pid", MED_TYPE_INT | MED_TYPE_READ_ONLY, OFFS(parent_pid), sizeof(int) },
	{ "child_pid", MED_TYPE_INT | MED_TYPE_READ_ONLY, OFFS(child_pid), sizeof(int) },
	{ "sibling_pid", MED_TYPE_INT | MED_TYPE_READ_ONLY, OFFS(sibling_pid), sizeof(int) },
	{ "pgrp", MED_TYPE_INT, OFFS(pgrp), sizeof(int) },
	{ "uid", MED_TYPE_UNSIGNED | MED_TYPE_SHORT, OFFS(uid), sizeof(unsigned short) },
	{ "euid", MED_TYPE_UNSIGNED | MED_TYPE_SHORT, OFFS(euid), sizeof(unsigned short) },
	{ "suid", MED_TYPE_UNSIGNED | MED_TYPE_SHORT, OFFS(suid), sizeof(unsigned short) },
	{ "fsuid", MED_TYPE_UNSIGNED | MED_TYPE_SHORT, OFFS(fsuid), sizeof(unsigned short) },
	{ "gid", MED_TYPE_UNSIGNED | MED_TYPE_SHORT, OFFS(gid), sizeof(unsigned short) },
	{ "egid", MED_TYPE_UNSIGNED | MED_TYPE_SHORT, OFFS(egid), sizeof(unsigned short) },
	{ "sgid", MED_TYPE_UNSIGNED | MED_TYPE_SHORT, OFFS(sgid), sizeof(unsigned short) },
	{ "fsgid", MED_TYPE_UNSIGNED | MED_TYPE_SHORT, OFFS(fsgid), sizeof(unsigned short) },
	{ "luid", MED_TYPE_UNSIGNED | MED_TYPE_SHORT, OFFS(luid), sizeof(unsigned short) },
	{ "cap_effective", MED_TYPE_BITMAP | MED_TYPE_FIXED_SIZE, OFFS(cap_effective), sizeof(kernel_cap_t) },
	{ "cap_inheritable", MED_TYPE_BITMAP | MED_TYPE_FIXED_SIZE, OFFS(cap_inheritable), sizeof(kernel_cap_t) },
	{ "cap_permitted", MED_TYPE_BITMAP | MED_TYPE_FIXED_SIZE, OFFS(cap_permitted), sizeof(kernel_cap_t) },
	{ "mp.vs", MED_TYPE_BITMAP | MED_TYPE_FIXED_SIZE, OFFS(mp.med_vs), sizeof(__u32) },
	{ "mp.vss", MED_TYPE_BITMAP | MED_TYPE_FIXED_SIZE, OFFS(mp.med_vs_s), sizeof(__u32) },
	{ "mp.vsr", MED_TYPE_BITMAP | MED_TYPE_FIXED_SIZE, OFFS(mp.med_vs_r), sizeof(__u32) },
	{ "mp.vsw", MED_TYPE_BITMAP | MED_TYPE_FIXED_SIZE, OFFS(mp.med_vs_w), sizeof(__u32) },
	{ "mp.act", MED_TYPE_BITMAP | MED_TYPE_FIXED_SIZE, OFFS(mp.med_act), sizeof(__u32) },
	{ "mp.iact", MED_TYPE_BITMAP | MED_TYPE_FIXED_SIZE, OFFS(mp.med_iact), sizeof(__u32) },
	{ "mp.user", MED_TYPE_BITMAP | MED_TYPE_FIXED_SIZE, OFFS(mp.user), sizeof(__u32) }, 
#ifdef CONFIG_MEDUSA_SYSCALL
	{ "mp.syscall", MED_TYPE_BITMAP | MED_TYPE_FIXED_SIZE | MED_TYPE_READ_ONLY, OFFS(mp.med_syscall[0]), NR_syscalls } ,
#endif
	{ "", MED_TYPE_END, 0, 0 }
};

struct medusa_comm_class_s medusa_task_class {
	MEDUSA_COMM_DEFAULT_CLASS_HEADER,
	"task",
	sizeof(struct task_object),
	task_object_attrs
};


