#ifndef _MEDUSA_L3_REGISTRY_H
#define _MEDUSA_L3_REGISTRY_H

/*
 * Used by l2, l4 to access l3 registry services
 *
 * This file defines
 *		methods from l3_registry.c
 *		chained list medusa_comm_classes
 *		chained list medusa_comm_question_types
 */

extern struct medusa_comm_class_s * medusa_comm_classes;
extern rwlock_t medusa_class_lock;

extern struct medusa_comm_question_type_s * medusa_comm_question_types;
extern rwlock_t medusa_question_type_lock;

extern struct medusa_comm_server_s * medusa_servers[MEDUSA_SERVERS_MAX];
extern rwlock_t medusa_server_lock;

extern void medusa_l3_registry_init(void);

/* functions called by l2 code */
struct medusa_comm_question_type_s * medusa_register_question_type(struct medusa_comm_question_type_s * qt);

/* functions called by l4 code */
int medusa_register_server(struct medusa_comm_server_s * server); /* -1 on error, slotnr on success */
void medusa_unregister_server(int slotnr);

#endif
