#ifndef _MEDUSA_CONSTANTS_H
#define _MEDUSA_CONSTANTS_H

/* version of this communication protocol */
#define MEDUSA_COMM_VERSION	1

/* elementary data types for attributes */
#define MED_TYPE_END		0x00000000	/* termination constant */
#define MED_TYPE_CHAR		0x00000001
#define MED_TYPE_SHORT		0x00000002
#define MED_TYPE_INT		0x00000003
#define MED_TYPE_LONG		0x00000004
#define MED_TYPE_STRING		0x00000005
#define MED_TYPE_POINTER	0x00000006
#define MED_TYPE_BITMAP		0x00000007
#define MED_TYPE_FIXED_SIZE	0x00000008

#define MED_TYPE_UNSIGNED	0x00000100
#define MED_TYPE_BITMAP		0x00000200
#define MED_TYPE_READ_ONLY	0x00000400
#define MED_TYPE_PRIMARY_KEY	0x00000800

/* string lengths in comm structures */
#define MEDUSA_NAME_MAX 64

#define MEDUSA_CLASSNAME_MAX	MEDUSA_NAME_MAX
#define MEDUSA_ATTRNAME_MAX	MEDUSA_NAME_MAX
#define MEDUSA_INSTANCENAME_MAX	MEDUSA_NAME_MAX
#define MEDUSA_QUESTIONNAME_MAX	MEDUSA_NAME_MAX
#define MEDUSA_SERVERNAME_MAX	MEDUSA_NAME_MAX

/* macros for server bitmap management */
#define MEDUSA_SERVERS_MAX		(sizeof(unsigned long) * 8)
#define MEDUSA_SERVER_BITMAP		unsigned long server_bitmap
#define MEDUSA_SERVER_ZERO(PNAME)	do { (PNAME)->bitmap = 0ul; } while (0)
#define MEDUSA_SERVER_FULL(PNAME)	do { (PNAME)->bitmap = ~0ul; } while (0)
#define MEDUSA_SERVER_SET(PNAME,BIT)	do { (PNAME)->bitmap |= (1ul << ((BIT)-1)); } while (0) /* TODO: arch optimisation */
#define MEDUSA_SERVER_CLR(PNAME,BIT)	do { (PNAME)->bitmap &= ~(1ul << ((BIT)-1)); } while (0) /* TODO: arch optimisation */
#define MEDUSA_SERVER_ISSET(PNAME,BIT)	((PNAME)->bitmap & (1ul << ((BIT)-1))) /* TODO: arch optimisation */
#define MEDUSA_SERVER_FOREACH(PNAME,I)	for ((I)=1; (I); (I)<<=1) if ((PNAME)->bitmap & (I))

#endif

