#ifndef _MEDUSA_SERVER_H
#define _MEDUSA_SERVER_H

/*
 * Used by l3, l4
 *
 * This file defines
 *		SERVER (stored in l3, defined by l4) medusa_comm_server_s
 */

#include <linux/config.h>
#include "medusa_constants.h"

/**/
/**/

/* describes one layer 4 communication server */
struct medusa_comm_server_s {
	/* this is a part of default header; used by l3 code */
	unsigned long comm_version;

	int status;
#define MED_SERVER_READY	0x00
#define MED_SERVER_BUSY		0x01
#define MED_SERVER_SUSP		0x02

#ifdef CONFIG_MEDUSA_PROFILING
	unsigned long use_count;
#endif

	/* l4-defined data */
	char name[MEDUSA_SERVERNAME_MAX];
	int (* ask)(struct medusa_comm_question_s *); /* returns one of MED_xxx */
};

/* this should be at the beginning of medusa_comm_server_s data,
 * filled by l4-code */
#ifdef CONFIG_MEDUSA_PROFILING
#define MEDUSA_COMM_DEFAULT_SERVER_HEADER \
	MEDUSA_COMM_VERSION,	/* protocol version check */ \
	MED_SERVER_READY,	/* status */ \
	0			/* use_count */
#else
#define MEDUSA_COMM_DEFAULT_SERVER_HEADER \
	MEDUSA_COMM_VERSION, \
	MED_SERVER_READY
#endif


#endif

