#!/bin/bash

if [ $# -lt 3 ]; then
  echo "Usage: makediff <original_kernel_dir> <medusa_kernel_dir> <patch_name>"
  exit 1;
fi

DIFF="diff -urNX nopatch"
OKD="$1"
MKD="$2"
BPN="medusa-$3.diff"

function difffile() {
  COMMAND="$DIFF $OKD/$1 $MKD/$1"
  echo $COMMAND >>$BPN
  eval $COMMAND >>$BPN
}

function diffdir() {
  COMMAND="$DIFF $OKD/$1 $MKD/$1"
  eval $COMMAND >>$BPN
}

rm -f $BPN

difffile Makefile
diffdir include/linux
diffdir init 
diffdir kernel
diffdir ipc
diffdir fs/proc

difffile fs/attr.c
difffile fs/dcache.c
difffile fs/exec.c
difffile fs/inode.c
difffile fs/namei.c
difffile fs/open.c
difffile fs/super.c

diffdir Documentation

diffdir include/asm-i386
diffdir arch/i386

mkdir $1/medusa
diffdir medusa
rmdir $1/medusa

